## pandas 0.23.3+dfsg

=== debian/changelog ===
pandas (0.23.3+dfsg-4ubuntu1.1) eoan; urgency=medium

  * d/p/troubleshoot-CI-29294.patch: Partial cherry-pick from upstream master
    that fixes test_null_byte_char failure (LP: #1861124).

 -- Corey Bryant <corey.bryant@canonical.com>  Tue, 28 Jan 2020 10:30:44 -0500

pandas (0.23.3+dfsg-4ubuntu1) eoan; urgency=medium

  * Merge with Debian unstable, remaining changes:
    + Drop python2 support.
    + Drop the python2 autopkgtest.
    + Switch to using pybuild instead of python_distutils, without which
      the build fails due to undeclared dependency on the 'pyversions'
      command.
    + Fix wrong debian/source/options exclude.
  * Add crh_UA to skip_noencoding_locales.patch
  * Move files from /usr/lib/python3.7 to /usr/lib/python3

 -- Graham Inggs <ginggs@ubuntu.com>  Tue, 17 Sep 2019 10:31:58 +0000

pandas (0.23.3+dfsg-4) unstable; urgency=medium

  * Add self to Uploaders.
  * Recommend .xls format support also in Python 3.  (Closes: #880125)
  * Tests: don't call fixtures, as this is an error in pytest 4+.
  * Don't test datetime in locales with no encoding.
    (These are broken by a Python stdlib bug.)

 -- Rebecca N. Palmer <rebecca_palmer@zoho.com>  Sat, 14 Sep 2019 16:37:43 +0100

pandas (0.23.3+dfsg-3ubuntu3) eoan; urgency=medium

  * Drop the python2 autopkgtest.
  * Switch to using pybuild instead of python_distutils, without which
    the build fails due to undeclared dependency on the 'pyversions'
    command.
  * Fix wrong debian/source/options exclude.
  * debian/patches/0001-CLN-reorg-groupby-to-multiple-modules-21820.patch,
    debian/patches/0001-TST-Fail-on-warning-22699.patch,
    debian/patches/pytest-4.patch:
    cherry-picks for compatibility with pytest 4.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 20 Aug 2019 14:28:36 -0700

pandas (0.23.3+dfsg-3ubuntu2) eoan; urgency=medium

  * Drop python2 support.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 20 Aug 2019 13:40:24 -0700

pandas (0.23.3+dfsg-3ubuntu1) disco; urgency=medium

  * Merge with Debian unstable, remaining changes:
    + Skip python2 test_sum_overflow which OOMs on ppc64el

 -- Graham Inggs <ginggs@ubuntu.com>  Thu, 07 Mar 2019 12:48:23 +0000

pandas (0.23.3+dfsg-3) unstable; urgency=medium

  * Team upload.
  * Make np.array @ Series act the right way round.  (Closes: #923708)
  * Replace #918206 fix with a fix that doesn't change the return type
    and inplace-ness of np.array += DataFrame.  (Closes: #923707)
  * Fix missing page in documentation.

 -- Rebecca N. Palmer <rebecca_palmer@zoho.com>  Wed, 06 Mar 2019 22:19:34 +0000

pandas (0.23.3+dfsg-2ubuntu1) disco; urgency=medium

  * Skip python2 test_sum_overflow which OOMs on ppc64el 

 -- Graham Inggs <ginggs@ubuntu.com>  Wed, 06 Mar 2019 12:01:45 +0000

pandas (0.23.3+dfsg-2) unstable; urgency=medium

  * Team upload.
  * Don't fail the build on +dfsg versions.
  * Fix another d/copyright issue.
  * Add d/upstream/metadata.

 -- Rebecca N. Palmer <rebecca_palmer@zoho.com>  Sat, 02 Mar 2019 14:57:12 +0000

pandas (0.23.3+dfsg-1) unstable; urgency=medium

  * Team upload.
  * Fix DataFrame @ np.array matrix multiplication.  (Closes: #918206)
  * Fix documentation build (Sphinx now defaults to Python 3).
    (Closes: #804552, LP: #1803018)
  * Add documentation examples dependencies.
  * Update d/copyright.
  * Remove unlicensed files.

 -- Rebecca N. Palmer <rebecca_palmer@zoho.com>  Fri, 01 Mar 2019 23:02:18 +0000

pandas (0.23.3-1) unstable; urgency=medium

  * New upstream release
  * debian/patches
    - many upstreamed patches are removed and others refreshed

 -- Yaroslav Halchenko <debian@onerussian.com>  Sat, 28 Jul 2018 00:39:32 -0400

=== debian/control ===
Source: pandas
Section: python
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Yaroslav Halchenko <debian@onerussian.com>,
           Michael Hanke <michael.hanke@gmail.com>,
           Rebecca N. Palmer <rebecca_palmer@zoho.com>
Build-Depends: debhelper (>= 9),
               quilt,
               python3-nbsphinx | python3-sphinx (<= 1.4),
               python3-all-dev,
               python3-setuptools,
               cython3 (>= 0.17.1~) | cython (<< 0.17.1~),
               python3-bs4,
               python3-dateutil,
               python3-html5lib,
               python3-lxml,
               python3-matplotlib [!hurd-i386]| python-matplotlib (<< 1.2.0~) [!hurd-i386],
               python3-nose,
               python3-numpy (>= 1:1.7~),
               python3-openpyxl,
               python3-pytest,
               python3-scipy,
               python3-six,
               python3-sphinx (>= 1.0~),
               python3-tables [!m68k !sh4 !x32],
               python3-tk,
               python3-tz,
               python3-xlsxwriter,
               python3-xlrd,
               python3-xlwt,
               xvfb,
               xauth,
               xclip,
Build-Depends-Indep:
 ipython3,
# for style.ipynb
 pandoc <!nodoc>,
# these are for not having (as many) exception messages in documentation examples
# RC-buggy python3-feather-format <!nodoc>,
# not in Debian python3-pyarrow <!nodoc> | python3-fastparquet <!nodoc>,
# would rather not add a big dependency (R) right now python3-rpy2 <!nodoc>,
 python3-sqlalchemy <!nodoc>,
 python3-statsmodels <!nodoc>,
 python3-xarray <!nodoc>,
Build-Conflicts: python-tables (= 3.3.0-4), python3-tables (= 3.3.0-4)
X-Python3-Version: >= 3.2
Standards-Version: 4.1.1
Homepage: https://pandas.pydata.org/
Vcs-Browser: https://salsa.debian.org/science-team/pandas
Vcs-Git: https://salsa.debian.org/science-team/pandas.git

Package: python3-pandas
Architecture: all
Depends: ${misc:Depends}, ${python3:Depends},
         python3-numpy (>= 1:1.7~),
         python3-dateutil,
         python3-pandas-lib(>= ${source:Version}),
         python3-pkg-resources,
         python3-six,
Recommends: python3-scipy,
            python3-matplotlib,
            python3-numexpr,
            python3-tables,
            python3-tz,
            python3-xlrd,
            python3-openpyxl, python3-xlwt,
            python3-bs4,
            python3-html5lib,
            python3-lxml,
            python3-html5lib,
Suggests: python-pandas-doc
Description: data structures for "relational" or "labeled" data - Python 3
 pandas is a Python package providing fast, flexible, and expressive
 data structures designed to make working with "relational" or
 "labeled" data both easy and intuitive. It aims to be the fundamental
 high-level building block for doing practical, real world data
 analysis in Python. pandas is well suited for many different kinds of
 data:
 .
  - Tabular data with heterogeneously-typed columns, as in an SQL
    table or Excel spreadsheet
  - Ordered and unordered (not necessarily fixed-frequency) time
    series data.
  - Arbitrary matrix data (homogeneously typed or heterogeneous) with
    row and column labels
  - Any other form of observational / statistical data sets. The data
    actually need not be labeled at all to be placed into a pandas
    data structure
 .
 This package contains the Python 3 version.

Package: python-pandas-doc
Architecture: all
Section: doc
Depends: ${misc:Depends},
         libjs-jquery,
         libjs-mathjax
Suggests: python3-pandas
Description: documentation and examples for pandas
 This package contains documentation and example scripts for
 python3-pandas.

Package: python3-pandas-lib
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, ${python3:Depends}, python3-numpy (>=1:1.7~)
Description: low-level implementations and bindings for pandas - Python 3
 This is an add-on package for python-pandas providing
 architecture-dependent extensions.
 .
 This package contains the Python 3 version.

=== debian/rules ===
#!/usr/bin/make -f
# -*- mode: makefile; coding: utf-8 -*-

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# Pass hardening flags into distutils, explicitly
export CFLAGS   = $(shell dpkg-buildflags --get CFLAGS)
export CPPFLAGS = $(shell dpkg-buildflags --get CPPFLAGS)
export CXXFLAGS = $(shell dpkg-buildflags --get CXXFLAGS)

PACKAGE3_NAME = python3-pandas
PACKAGE3_ROOT_DIR = debian/${PACKAGE3_NAME}

PY3VERS = $(shell py3versions -vr)
PY3VER = $(shell py3versions -vd)

UVER := $(shell LC_ALL=C dpkg-parsechangelog | awk '/^Version:/{print $$2;}' | sed -e 's,-[^-]*$$,,g' | sed -e 's,+dfsg,,g')
# Python doesn't use ~ for rc
UVER_PY := $(shell echo $(UVER) | sed -e 's,[~],,g')
UVER_PYSHORT := $(shell echo $(UVER_PY) | sed -e 's,+git.*,,g')

# Filter out tests with "marker expressions" and "keyword expressions". Ref: pytest(1)
ifeq ($(DEB_HOST_ARCH),$(filter $(DEB_HOST_ARCH), amd64 i386 kfreebsd-amd64 kfreebsd-i386 x32))
	PYTEST_MARKER_ARCH :=
	PYTEST_KEYWORD_ARCH :=
else
	PYTEST_MARKER_ARCH := and not intel and not slow
	PYTEST_KEYWORD_ARCH :=
endif

# Some unittests might need to be excluded for different Python versions
PYTEST_MARKER := not single and not network and not disabled $(PYTEST_MARKER_ARCH)
EXCLUDE_TESTS := 
EXCLUDE_TESTS2 :=
EXCLUDE_TESTS3.2 :=
EXCLUDE_TESTS3.3 := 
EXCLUDE_TESTS3.4 := $(EXCLUDE_TESTS3.3)
EXCLUDE_TESTS3.5 := $(EXCLUDE_TESTS3.3)
EXCLUDE_TESTS3.6 :=
EXCLUDE_TESTS3.7 :=


ADDPATCHES :=
# testing for version became fragile: https://github.com/pytest-dev/pytest/issues/3692
# PYTESTVER := $(shell python -c 'import pytest; print(pytest.__version__)')
# and there is way too many uses of pytest.param now, so we can't just easily patch for it... THINK!
# ADDPATCHES += $(shell dpkg --compare-versions $(PYTESTVER) ge 3.1.0 || echo "0001-TST-pytest-deprecation-warnings-GH17197-17253-reversed.patch" )

# MPLVER := $(shell dpkg -l python-matplotlib | awk '/^ii/{print $$3;}' || echo 0)
# $(shell dpkg --compare-versions $(MPLVER) lt 1.0 && echo '|test_hist|test_plot|test_boxplot|test_corr_rank' || echo '')

# try to prevent unsunctioned downloads
export  http_proxy=http://127.0.0.1:9/
export  https_proxy=http://127.0.0.1:9/

export SHELL=/bin/bash

# Mega rule
%:
	: # Explicit build system to avoid use of all-in-1 Makefile
	dh $@ --buildsystem=pybuild --with python3

clean_generated:
	find pandas/ -regex '.*\.c\(\|pp\)' | xargs grep -l -e 'Generated by Cython'  | xargs -r rm -f

_cythonize%:
	debian/rules clean_generated # force removal of previous copies
	python$(*:2=) setup.py cython
	D=debian/cythonized-files$(*:2=) && \
		git rm -rf $$D; \
		find pandas/ -regex '.*\.c\(\|pp\)' | while read f; do \
			grep -q 'Generated by Cython' "$$f" || continue; \
			mkdir -p "$$D/$$(dirname $$f)"; \
			cp "$$f" "$$D/$$(dirname $$f)"; \
			git add -f "$$D/$$f"; \
		done; \
		echo "$(UVER)" >| $$D/VERSION; git add $$D/VERSION

cythonize: _cythonize3

override_dh_clean: clean_generated
	: # Make sure that cythonized sources are up-to-date
	[ "$(UVER)" = "`cat debian/cythonized-files/VERSION`" ]
	rm -rf build doc/_build *-stamp # pandas.egg-info pandas/datasets/__config__.py
	dh_clean

version_py:
	[ -e pandas/__version.py ] || \
      echo -e "version = '$(UVER_PY)'\nshort_version = '$(UVER_PYSHORT)'" > pandas/__version.py

override_dh_auto_build: version_py debian/patch-stamp
	dh_auto_build

debian/patch-stamp:
	if echo "${ADDPATCHES}" | sed -e 's,\s,,g' | grep  '.' ; then \
       echo ${ADDPATCHES} >> debian/patches/series; \
	   quilt push -a; \
    fi
	touch $@

override_dh_auto_install:
	dh_auto_install

override_dh_auto_test: override_dh_auto_install
	set -e; \
	for ver in ${PY3VERS}; do \
		debian/rules python-test$$ver; \
	done

python-test%:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	echo "backend : Agg" >| $(CURDIR)/build/matplotlibrc
	: # Run unittests here against installed pandas
	export PYTHONPATH=`/bin/ls -d $$PWD/debian/tmp/usr/lib/python$*/*/`; \
	export MPLCONFIGDIR=$(CURDIR)/build HOME=$(CURDIR)/build; \
	python$* ci/print_versions.py; \
    cd build/; LOCALE_OVERRIDE=C xvfb-run -a -s "-screen 0 1280x1024x24 -noreset" \
      python$* -m pytest -s -v -m "$(PYTEST_MARKER)" $(EXCLUDE_TESTS) $(EXCLUDE_TESTS$*) $(EXCLUDE_TESTS_ARCH) $$PYTHONPATH/pandas;
else
	: # Skip unittests due to nocheck
endif

override_dh_installdocs:
	: # Build Documentation using installed pandas
ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
ifneq (,$(findstring -a,$(DH_INTERNAL_OPTIONS)))
	: # not building documentation in -a
else
	cd doc && PYTHONPATH=$(CURDIR)/$(PACKAGE3_ROOT_DIR)-lib/usr/lib/python3/dist-packages:$(CURDIR)/$(PACKAGE3_ROOT_DIR)/usr/lib/python3/dist-packages MPLCONFIGDIR=$(CURDIR)/build HOME=$(CURDIR)/build LC_ALL=C python3 make.py html
endif
endif
	: # Use jquery from Debian package, so prune shipped one
	#TODO -rm doc/_build/html/_static/jquery.js
	dh_installdocs -A *.md

override_dh_install:
	find debian -name __pycache__ | xargs rm -rf
	mv debian/tmp/usr/lib/python3.7 debian/tmp/usr/lib/python3
	dh_install

## remove .so libraries from main package, and call dh_numpy*
## while removing 2 if not present
_dh_python%:
	[ -e /usr/bin/dh_numpy$(*:2=) ] && dh_numpy$(*:2=) -p$(PACKAGE$*_NAME)-lib || :
	dh_python$*
	-find debian/python*-pandas -name "*.so" -delete

## "Instantiate" both rules so dh sees them
override_dh_python3: _dh_python3

## immediately useable documentation and exemplar scripts/data
override_dh_compress:
	dh_compress -X.py -X.html -X.pdf -X.css -X.jpg -X.txt -X.js -X.json -X.rtc -Xobjects.inv

# This has no effect at all since the tests are run in binary-arch instead of auto_test ...
#ifeq ($(DEB_HOST_ARCH),$(filter $(DEB_HOST_ARCH),  armhf mips s390x hppa powerpc ppc64 sparc64))
#override_dh_auto_test:
#	dh_auto_test || true
#endif

=== debian/tests/control ===
# According to pandas/doc/source/install.rst, running the unit tests looks like:
# `py.test-3 --skip-slow --skip-network /usr/lib/python3/dist-packages/pandas/ -v -rs`
# Or simply `python3 -c "import pandas as pd; pd.test()"`, which doesn't require
# us to specify the path (pandas.__path__) in command line.
# See: pandas/util/_tester.py

Tests: unittests3
Depends: python3-all,
         python3-arrow,
         python3-bs4,
         python3-dateutil,
         python3-html5lib,
         python3-lxml,
         python3-matplotlib [!hurd-i386]| python-matplotlib (<< 1.2.0~) [!hurd-i386],
         python3-nose,
         python3-numpy (>= 1:1.7~),
         python3-openpyxl,
         python3-pandas,
         python3-pytest,
         python3-scipy,
         python3-six,
         python3-sphinx (>= 1.0~),
         python3-tables [!m68k !sh4 !x32],
         python3-tk,
         python3-tz,
         python3-xlrd,
         python3-xlsxwriter,
         python3-xlwt,
         xauth,
         xvfb,
         xclip,
Restrictions: allow-stderr

## pandas 0.25.3+dfsg

=== Makefile ===
.PHONY : develop build clean clean_pyc doc lint-diff black

all: develop

clean:
	-python setup.py clean

clean_pyc:
	-find . -name '*.py[co]' -exec rm {} \;

build: clean_pyc
	python setup.py build_ext --inplace

lint-diff:
	git diff upstream/master --name-only -- "*.py" | xargs flake8

black:
	black . --exclude '(asv_bench/env|\.egg|\.git|\.hg|\.mypy_cache|\.nox|\.tox|\.venv|_build|buck-out|build|dist|setup.py)'

develop: build
	python setup.py develop

doc:
	-rm -rf doc/build doc/source/generated
	cd doc; \
	python make.py clean; \
	python make.py html

=== debian/changelog ===
pandas (0.25.3+dfsg-7) unstable; urgency=medium

  * Fix another test failure due to our warnings.
  * Skip rather than xfail crashing tests.

 -- Rebecca N. Palmer <rebecca_palmer@zoho.com>  Wed, 26 Feb 2020 18:45:58 +0000

pandas (0.25.3+dfsg-6) unstable; urgency=medium

  * Don't fail tests on our own warnings.
  * Xfail some more HDF tests on non-x86 architectures.
  * Warn that clipboard I/O is broken on big-endian architectures
    and xfail test.
  * Use pytest-forked to isolate (already xfailed) crashing test.
  * Xfail tests that use no-longer-existing URLs.

 -- Rebecca N. Palmer <rebecca_palmer@zoho.com>  Wed, 26 Feb 2020 07:40:25 +0000

pandas (0.25.3+dfsg-5) unstable; urgency=medium

  * Backport packaging from experimental:
    - Remove unnecessary test skips, and reorganize remaining ones.
    - Use xfails instead of skips.
    - Add warnings for the known non-x86 breakages
      (NaN -> datetime #877754, HDF and Stata I/O #877419).
    - Tell I/O tests where to find the source tree's test data
      instead of skipping them.
    - Stop using deprecated envvar/tag names.
    - Use https for links where available.

 -- Rebecca N. Palmer <rebecca_palmer@zoho.com>  Mon, 24 Feb 2020 22:38:26 +0000

pandas (0.25.3+dfsg-4) unstable; urgency=medium

  * No-change upload to unstable.  (Closes: #937236, #931557)

 -- Rebecca N. Palmer <rebecca_palmer@zoho.com>  Sun, 10 Nov 2019 16:35:41 +0000

pandas (0.25.3+dfsg-3) experimental; urgency=medium

  * Fix autopkgtest.

 -- Rebecca N. Palmer <rebecca_palmer@zoho.com>  Sat, 09 Nov 2019 10:29:47 +0000

pandas (0.25.3+dfsg-2) experimental; urgency=medium

  * Split up the test suite to fit in memory on mipsel,
    and stop ignoring it there.  (Closes: #943732)
  * Reproducibility: use correct path for stripping docs.
  * Declare transition Breaks (see #931557).
  * Tests: ignore warning from Python 3.8.
  * Update d/copyright (some files have moved).
  * Use local requirejs.

 -- Rebecca N. Palmer <rebecca_palmer@zoho.com>  Fri, 08 Nov 2019 07:56:16 +0000

pandas (0.25.3+dfsg-1) experimental; urgency=medium

  * Upstream bugfix release.
  * Drop patch no longer needed.
  * Update autopkgtest dependencies, drop unused link.
  * Better document test skips, remove unnecessary ones.
  * Reproducibility: strip timestamps and build paths,
    use fixed random seeds for building documentation.
  * Ignore test suite on mipsel.

 -- Rebecca N. Palmer <rebecca_palmer@zoho.com>  Sat, 02 Nov 2019 22:26:31 +0000

pandas (0.25.2+dfsg-2) experimental; urgency=medium

  * Correct path for contributors list, and don't fail when
    not building the -doc package.
  * Try again to fix test failure due to deb_nonversioneer_version.
  * Skip some failing tests on non-Intel (see #943732),
    require other tests to pass.
  * Fix another typo.

 -- Rebecca N. Palmer <rebecca_palmer@zoho.com>  Mon, 28 Oct 2019 22:06:10 +0000

pandas (0.25.2+dfsg-1) experimental; urgency=medium

  [ Graham Inggs ]
  * Skip python2 test_register_by_default on s390x
  * Fix python2 test failures in certain locales

  [ Yaroslav Halchenko ]
  * Recent upstream release
  * Updated patches
  * Adjusted for the gone ci/print_versions
  * d/control
    - added python{,3}-hypothesis to b-depends

  [ Rebecca N. Palmer ]
  * New upstream release.
  * Upload to experimental, as this is an API break (see #931557).
  * Drop patches fixed upstream, refresh others.
  * Remove Python 2 packages (see #937236).
  * Use Python 3 in shebangs and subprocess calls.
  * Re-enable building on Python 3.8.
  * Use the new location of print_versions.
  * Skip feather tests and remove build-dependency:
    they now need pyarrow.feather, which isn't in Debian.
  * Don't fail tests for our versioneer removal
    or a differently worded error message.
  * Add/update minimum dependency versions.
  * Add numpydoc, nbconvert and pytest-xdist build-depends.
  * Update d/copyright.
  * Pre-generate a contributor list to avoid needing the git log
    at build time (when it won't exist).
  * Allow tests to fail for now.

 -- Rebecca N. Palmer <rebecca_palmer@zoho.com>  Mon, 28 Oct 2019 07:53:21 +0000

pandas (0.23.3+dfsg-8) unstable; urgency=medium

  * Examples dependencies: re-add statsmodels and xarray;
    also add rpy2 and feather.
  * Use packaged intersphinx indexes.  (Closes: #876417)
  * Use https for intersphinx links.
  * Remove cythonized-files*.  (They are regenerated on each build.)
  * Remove test xfail, as statsmodels has now been fixed.
  * Set Rules-Requires-Root: no.
  * Make documentation Suggest the Python 3 version.
  * Suggest statsmodels.
  * Only use Python 3 sphinx, and mark it -Indep/nodoc.
  * Bump debhelper compat to 12 and use debhelper-compat and pybuild.
  * Remove pycompat and X-Python*-Version.
  * Add missing d/copyright item.
  * Remove obsolete TODOs.
  * Clarify descriptions.
  * Stop referring to examples that no longer exist.
  * Fix typos.
  * Remove old (no longer used) EXCLUDE_TESTS*.
  * Deduplicate documentation files.
  * Use Python 3 shebangs, and fix broken shebang.
  * Add python3-ipykernel, -ipywidgets, -seaborn to
    Build-Depends-Indep.
  * Disable dh_auto_test: it fails, and we run the tests elsewhere.
  * Mark test dependencies nocheck/nodoc.
  * Remove old minimum versions / alternative dependencies.
  * Build-depend on dh-python.
  * Don't build on python3.8, as it will fail tests (see #931557).

 -- Rebecca N. Palmer <rebecca_palmer@zoho.com>  Sun, 27 Oct 2019 11:38:37 +0000

pandas (0.23.3+dfsg-7) unstable; urgency=medium

  * Revert test patch and use an xfail instead.
  * Temporarily drop statsmodels+xarray Build-Depends, as they are
    uninstallable until this is built.
  * Add python3-xarray to autopkgtest Depends.
  * Drop Python 2 autopkgtest (but keep build-time test).
  * Remove duplicate Recommends.

 -- Rebecca N. Palmer <rebecca_palmer@zoho.com>  Fri, 20 Sep 2019 08:01:37 +0100

pandas (0.23.3+dfsg-6) unstable; urgency=medium

  * Team upload


=== debian/control ===
Source: pandas
Section: python
Priority: optional
Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Yaroslav Halchenko <debian@onerussian.com>,
           Michael Hanke <michael.hanke@gmail.com>,
           Rebecca N. Palmer <rebecca_palmer@zoho.com>
Build-Depends: debhelper-compat (= 12),
               dh-python,
               locales-all,
               quilt,
               python3-all-dev,
               python3-setuptools,
               cython3 (>= 0.29.13~),
               python3-bs4 <!nocheck> <!nodoc>,
               python3-dateutil,
               python3-hypothesis <!nocheck> <!nodoc>,
               python3-html5lib <!nocheck> <!nodoc>,
               python3-lxml <!nocheck> <!nodoc>,
               python3-matplotlib [!hurd-i386],
               python3-nose <!nocheck> <!nodoc>,
               python3-numpy,
               python3-openpyxl <!nocheck> <!nodoc>,
               python3-pytest (>= 4.0.2~) <!nocheck> <!nodoc>,
               python3-pytest-xdist <!nocheck> <!nodoc>,
               python3-pytest-forked <!nocheck> <!nodoc>,
               python3-scipy,
               python3-six,
               python3-tables (>= 3.4.2~) [!m68k !sh4 !x32] <!nocheck> <!nodoc>,
               python3-tk <!nocheck> <!nodoc>,
               python3-tz <!nocheck> <!nodoc>,
               python3-xlsxwriter <!nocheck> <!nodoc>,
               python3-xlrd <!nocheck> <!nodoc>,
               python3-xlwt <!nocheck> <!nodoc>,
               xvfb <!nocheck>,
               xauth <!nocheck>,
               xclip <!nocheck>,
Build-Depends-Indep:
 python3-sphinx <!nodoc>,
 python3-nbsphinx <!nodoc>,
 python3-ipykernel <!nodoc>,
 python3-numpydoc <!nodoc>,
 python3-nbconvert (>= 5.4.1~) <!nodoc>,
 ipython3 <!nodoc>,
 jdupes <!nodoc>,
# for style.ipynb
 pandoc <!nodoc>,
# for intersphinx inventories
 python3-doc <!nodoc>,
 python-numpy-doc <!nodoc>,
 python-scipy-doc <!nodoc>,
 python-matplotlib-doc <!nodoc>,
 python-statsmodels-doc <!nodoc>,
# these are for not having (as many) exception messages in documentation examples
# so may be temporarily removed if they are broken or to break bootstrap cycles
# not in Debian (not to be confused with python3-arrow) python3-pyarrow <!nodoc>,
 python3-rpy2 <!nodoc>,
 python3-sqlalchemy <!nodoc>,
 python3-statsmodels <!nodoc>,
 python3-xarray <!nodoc>,
 python3-ipywidgets <!nodoc>,
 python3-seaborn <!nodoc>
Standards-Version: 4.1.1
# TODO for 4.4.1: release notes install (Policy 12.7)
Rules-Requires-Root: no
Homepage: https://pandas.pydata.org/
Vcs-Browser: https://salsa.debian.org/science-team/pandas
Vcs-Git: https://salsa.debian.org/science-team/pandas.git

Package: python3-pandas
Architecture: all
Depends: ${misc:Depends}, ${python3:Depends},
         python3-numpy (>= 1:1.15~),
         python3-dateutil,
         python3-pandas-lib(>= ${source:Version}),
         python3-pkg-resources,
         python3-six,
Recommends: python3-scipy,
            python3-matplotlib,
            python3-numexpr,
            python3-tables,
            python3-tz,
            python3-xlrd,
            python3-openpyxl, python3-xlwt,
            python3-bs4,
            python3-html5lib,
            python3-lxml,
Suggests: python-pandas-doc,
          python3-statsmodels
# 0.23 -> 0.25 API breaks, #931557 - assumes the not-yet-fixed ones are fixed on next upload, but is better than nothing
Breaks: cnvkit (<< 0.9.6-1.1),
        python3-feather-format (<< 0.3.1+dfsg1-2.1),
        python3-skbio (<< 0.5.5-2.1),
        python3-statsmodels (<< 0.10.0~),
        q2-types (<< 2019.7.0-1.1)
Description: data structures for "relational" or "labeled" data
 pandas is a Python package providing fast, flexible, and expressive
 data structures designed to make working with "relational" or
 "labeled" data both easy and intuitive. It aims to be the fundamental
 high-level building block for doing practical, real world data
 analysis in Python. pandas is well suited for many different kinds of
 data:
 .
  - Tabular data with heterogeneously-typed columns, as in an SQL
    table or Excel spreadsheet
  - Ordered and unordered (not necessarily fixed-frequency) time
    series data.
  - Arbitrary matrix data (homogeneously typed or heterogeneous) with
    row and column labels
  - Any other form of observational / statistical data sets. The data
    actually need not be labeled at all to be placed into a pandas
    data structure
 .
 This package contains the Python 3 version.

Package: python-pandas-doc
Architecture: all
Section: doc
Depends: ${misc:Depends},
         libjs-jquery,
         libjs-requirejs,
         libjs-mathjax
Suggests: python3-pandas
Description: data structures for "relational" or "labeled" data - documentation
 pandas is a Python package providing fast, flexible, and expressive
 data structures designed to make working with "relational" or
 "labeled" data both easy and intuitive. It aims to be the fundamental
 high-level building block for doing practical, real world data
 analysis in Python. pandas is well suited for many different kinds of
 data:
 .
  - Tabular data with heterogeneously-typed columns, as in an SQL
    table or Excel spreadsheet
  - Ordered and unordered (not necessarily fixed-frequency) time
    series data.
  - Arbitrary matrix data (homogeneously typed or heterogeneous) with
    row and column labels
  - Any other form of observational / statistical data sets. The data
    actually need not be labeled at all to be placed into a pandas
    data structure
 .
 This package contains the documentation.

Package: python3-pandas-lib
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, ${python3:Depends}, python3-numpy (>=1:1.15~)
Description: low-level implementations and bindings for pandas
 This is a low-level package for python3-pandas providing
 architecture-dependent extensions.
 .
 Users should not need to install it directly.

=== debian/rules ===
--- 
+++ 
@@ -13,11 +13,15 @@
 
 PY3VERS = $(shell py3versions -vr)
 PY3VER = $(shell py3versions -vd)
+SOURCE_DATE:=$(shell date -u -d "@$(SOURCE_DATE_EPOCH)" "+%a, %d %b %Y" || echo "xxx, xx xxx xxxx")
+SOURCE_TIME:=$(shell date -u -d "@$(SOURCE_DATE_EPOCH)" "+%T" || echo "xx:xx:xx")
 
 UVER := $(shell LC_ALL=C dpkg-parsechangelog | awk '/^Version:/{print $$2;}' | sed -e 's,-[^-]*$$,,g' | sed -e 's,+dfsg,,g')
 # Python doesn't use ~ for rc
 UVER_PY := $(shell echo $(UVER) | sed -e 's,[~],,g')
 UVER_PYSHORT := $(shell echo $(UVER_PY) | sed -e 's,+git.*,,g')
+
+MIN_CYTHONVER = 0.23
 
 # Filter out tests with "marker expressions" and "keyword expressions". Ref: pytest(1)
 ifeq ($(DEB_HOST_ARCH),$(filter $(DEB_HOST_ARCH), amd64 i386 kfreebsd-amd64 kfreebsd-i386 x32))
@@ -28,17 +32,7 @@
 	PYTEST_KEYWORD_ARCH :=
 endif
 
-# Some unittests might need to be excluded for different Python versions
-PYTEST_MARKER := not single and not network and not disabled $(PYTEST_MARKER_ARCH)
-EXCLUDE_TESTS := 
-EXCLUDE_TESTS2 :=
-EXCLUDE_TESTS3.2 :=
-EXCLUDE_TESTS3.3 := 
-EXCLUDE_TESTS3.4 := $(EXCLUDE_TESTS3.3)
-EXCLUDE_TESTS3.5 := $(EXCLUDE_TESTS3.3)
-EXCLUDE_TESTS3.6 :=
-EXCLUDE_TESTS3.7 :=
-
+PYTEST_MARKER := not network $(PYTEST_MARKER_ARCH)
 
 ADDPATCHES :=
 # testing for version became fragile: https://github.com/pytest-dev/pytest/issues/3692
@@ -76,11 +70,19 @@
 		done; \
 		echo "$(UVER)" >| $$D/VERSION; git add $$D/VERSION
 
+_uncythonize%:
+	echo "$*" | grep -q '^3' && PY=3 || PY= ; \
+	CYTHONVER=$$(dpkg -l cython$$PY 2>/dev/null | awk '/^ii/{print $$3;}' || echo 0); \
+	dpkg --compare-versions "$$CYTHONVER" lt "$(MIN_CYTHONVER)" && { \
+		echo "I: Using pre-Cython-ed files for Python $*"; \
+		cd debian/cythonized-files$$PY/ ; \
+		find . -regex '.*\.c\(\|pp\)' | while read f; do cp $$f ../../$$f; done; } || :
+
 cythonize: _cythonize3
 
 override_dh_clean: clean_generated
 	: # Make sure that cythonized sources are up-to-date
-	[ "$(UVER)" = "`cat debian/cythonized-files/VERSION`" ]
+	[ ! -e debian/cythonized-files3/VERSION ] || [ "$(UVER)" = "`cat debian/cythonized-files3/VERSION`" ]
 	rm -rf build doc/_build *-stamp # pandas.egg-info pandas/datasets/__config__.py
 	dh_clean
 
@@ -89,7 +91,10 @@
       echo -e "version = '$(UVER_PY)'\nshort_version = '$(UVER_PYSHORT)'" > pandas/__version.py
 
 override_dh_auto_build: version_py debian/patch-stamp
-	dh_auto_build
+	# Override default build operation which --force's re-cythonization
+	# on elderly ubuntus
+	# Just build the version.py file
+	:
 
 debian/patch-stamp:
 	if echo "${ADDPATCHES}" | sed -e 's,\s,,g' | grep  '.' ; then \
@@ -98,24 +103,24 @@
     fi
 	touch $@
 
-override_dh_auto_install:
-	dh_auto_install
 
-override_dh_auto_test: override_dh_auto_install
-	set -e; \
-	for ver in ${PY3VERS}; do \
-		debian/rules python-test$$ver; \
-	done
+override_dh_auto_install: ${PY3VERS:%=python-install%} ${PY3VERS:%=python-test%}
+# Per Python version logic -- install, test, remomove .so (installed into -lib)
+python-install%: _uncythonize%
+	python$* setup.py install --install-layout=deb --root=$(CURDIR)/debian/tmp
 
-python-test%:
+python-test%: python-install%
 ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
 	echo "backend : Agg" >| $(CURDIR)/build/matplotlibrc
-	: # Run unittests here against installed pandas
-	export PYTHONPATH=`/bin/ls -d $$PWD/debian/tmp/usr/lib/python$*/*/`; \
-	export MPLCONFIGDIR=$(CURDIR)/build HOME=$(CURDIR)/build; \
-	python$* ci/print_versions.py; \
-    cd build/; LOCALE_OVERRIDE=C xvfb-run -a -s "-screen 0 1280x1024x24 -noreset" \
-      python$* -m pytest -s -v -m "$(PYTEST_MARKER)" $(EXCLUDE_TESTS) $(EXCLUDE_TESTS$*) $(EXCLUDE_TESTS_ARCH) $$PYTHONPATH/pandas;
+	: # Run unittests here against installed pandas, in sections to avoid out-of-memory crash (#943732); exit code 5 means no tests in this file
+	echo "$*" | grep -q '^3' && PY=3 || PY=$*; \
+	 export PYTHONPATH=`/bin/ls -d $$PWD/debian/tmp/usr/lib/python$$PY/*/`; \
+	 export MPLCONFIGDIR=$(CURDIR)/build HOME=$(CURDIR)/build; \
+	 python$* pandas/util/_print_versions.py; \
+	 cd build/; TEST_SUCCESS=true; for TEST_SUBSET in $${PYTHONPATH}/pandas/tests/* ; do \
+	 LOCALE_OVERRIDE=C xvfb-run -a -s "-screen 0 1280x1024x24 -noreset" \
+	 python$* -m pytest -s -v -m "$(PYTEST_MARKER)" --confcutdir=$${PYTHONPATH}/pandas --deb-data-root-dir=$(CURDIR)/pandas/tests --strict-data-files $${TEST_SUBSET} || test $$? == 5 || TEST_SUCCESS=false \
+	 ; done ; $${TEST_SUCCESS}
 else
 	: # Skip unittests due to nocheck
 endif
@@ -127,16 +132,26 @@
 	: # not building documentation in -a
 else
 	cd doc && PYTHONPATH=$(CURDIR)/$(PACKAGE3_ROOT_DIR)-lib/usr/lib/python3/dist-packages:$(CURDIR)/$(PACKAGE3_ROOT_DIR)/usr/lib/python3/dist-packages MPLCONFIGDIR=$(CURDIR)/build HOME=$(CURDIR)/build LC_ALL=C python3 make.py html
+	# strip build paths and statsmodels timestamps for reproducibility, and online Javascript for privacy
+	for html in `find doc/build/html -name _modules -prune -o -name "*.html" -o -name "*.ipynb"` ; do \
+	    sed -i -e 's#$(CURDIR)/.pybuild/[^/]*/build/pandas/#/usr/lib/python3/dist-packages/pandas/#g' \
+	    -e 's#$(CURDIR)/debian/python3-pandas/usr/lib/python3/dist-packages/pandas/#/usr/lib/python3/dist-packages/pandas/#g' \
+	    -e 's#<script crossorigin="anonymous" integrity="sha256-Ae2Vz/4ePdIu6ZyI/5ZGsYnb+m0JlOmKPjt6XZ9JJkA=" type="text/javascript" src="https://cdnjs\.cloudflare\.com/ajax/libs/require\.js/2\.3\.4/require\.min\.js">#<script crossorigin="anonymous" type="text/javascript" src="file:///usr/share/javascript/requirejs/require.min.js">#g' \
+	    -e 's#\(Date:.*\)[A-Z][a-z]\+, \+[0-9]\+,\? \+[A-Z][a-z]\+,\? \+[0-9]\+#\1$(SOURCE_DATE)#g' \
+	    -e 's#\(Time:.*\)[0-9][0-9]:[0-9][0-9]:[0-9][0-9]#\1$(SOURCE_TIME)#g' $${html} ; \
+	done
 endif
 endif
 	: # Use jquery from Debian package, so prune shipped one
 	#TODO -rm doc/_build/html/_static/jquery.js
 	dh_installdocs -A *.md
+	cp -av debian/contributors_list.txt debian/python-pandas-doc/usr/share/doc/python-pandas-doc || true
+	# deduplicate files - the ||true is because we only build-depend on jdupes if we're building documentation
+	jdupes -r -l debian/python-pandas-doc/usr/share/doc || true
 
 override_dh_install:
+	dh_install
 	find debian -name __pycache__ | xargs rm -rf
-	mv debian/tmp/usr/lib/python3.7 debian/tmp/usr/lib/python3
-	dh_install
 
 ## remove .so libraries from main package, and call dh_numpy*
 ## while removing 2 if not present
@@ -152,8 +167,6 @@
 override_dh_compress:
 	dh_compress -X.py -X.html -X.pdf -X.css -X.jpg -X.txt -X.js -X.json -X.rtc -Xobjects.inv
 
-# This has no effect at all since the tests are run in binary-arch instead of auto_test ...
-#ifeq ($(DEB_HOST_ARCH),$(filter $(DEB_HOST_ARCH),  armhf mips s390x hppa powerpc ppc64 sparc64))
-#override_dh_auto_test:
-#	dh_auto_test || true
-#endif
+override_dh_auto_test:
+	# do nothing here, we run tests in python-test% instead
+	true

=== debian/tests/control ===
--- 
+++ 
@@ -5,24 +5,27 @@
 # See: pandas/util/_tester.py
 
 Tests: unittests3
-Depends: python3-all,
-         python3-arrow,
+Depends: locales-all,
+         python3-all,
          python3-bs4,
          python3-dateutil,
          python3-html5lib,
+         python3-hypothesis,
          python3-lxml,
-         python3-matplotlib [!hurd-i386]| python-matplotlib (<< 1.2.0~) [!hurd-i386],
+         python3-matplotlib [!hurd-i386],
          python3-nose,
-         python3-numpy (>= 1:1.7~),
+         python3-numpy (>= 1:1.15~),
          python3-openpyxl,
          python3-pandas,
-         python3-pytest,
+         python3-pytest (>= 4.0.2~),
+         python3-pytest-forked,
          python3-scipy,
          python3-six,
-         python3-sphinx (>= 1.0~),
-         python3-tables [!m68k !sh4 !x32],
+         python3-statsmodels,
+         python3-tables (>= 3.4.2~) [!m68k !sh4 !x32],
          python3-tk,
          python3-tz,
+         python3-xarray,
          python3-xlrd,
          python3-xlsxwriter,
          python3-xlwt,
